SDL_sensor.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_sensor.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_STANDARD_GRAVITY 9.80665f

## Typedefs

typedef Sint32 | SDL_SensorID

## Enumerations

enum | SDL_SensorType { SDL_SENSOR_INVALID = -1, SDL_SENSOR_UNKNOWN, SDL_SENSOR_ACCEL, SDL_SENSOR_GYRO }

## Functions

int | SDL_NumSensors (void)
| Count the number of sensors attached to the system right now. More...
const char * | SDL_SensorGetDeviceName (int device_index)
| Get the implementation dependent name of a sensor. More...
SDL_SensorType | SDL_SensorGetDeviceType (int device_index)
| Get the type of a sensor. More...
int | SDL_SensorGetDeviceNonPortableType (int device_index)
| Get the platform dependent type of a sensor. More...
SDL_SensorID | SDL_SensorGetDeviceInstanceID (int device_index)
| Get the instance ID of a sensor. More...
SDL_Sensor * | SDL_SensorOpen (int device_index)
| Open a sensor for use. More...
SDL_Sensor * | SDL_SensorFromInstanceID (SDL_SensorID instance_id)
const char * | SDL_SensorGetName (SDL_Sensor *sensor)
| Get the implementation dependent name of a sensor. More...
SDL_SensorType | SDL_SensorGetType (SDL_Sensor *sensor)
| Get the type of a sensor. More...
int | SDL_SensorGetNonPortableType (SDL_Sensor *sensor)
| Get the platform dependent type of a sensor. More...
SDL_SensorID | SDL_SensorGetInstanceID (SDL_Sensor *sensor)
| Get the instance ID of a sensor. More...
int | SDL_SensorGetData (SDL_Sensor *sensor, float *data, int num_values)
void | SDL_SensorClose (SDL_Sensor *sensor)
void | SDL_SensorUpdate (void)

## Detailed Description

Include file for SDL sensor event handling

Definition in file SDL_sensor.h.

## Macro Definition Documentation

## SDL_STANDARD_GRAVITY

#define SDL_STANDARD_GRAVITY 9.80665f

Accelerometer sensor

The accelerometer returns the current acceleration in SI meters per second squared. This includes gravity, so a device at rest will have an acceleration of SDL_STANDARD_GRAVITY straight down.

values[0]: Acceleration on the x axis values[1]: Acceleration on the y axis values[2]: Acceleration on the z axis

For phones held in portrait mode, the axes are defined as follows: -X ... +X : left ... right -Y ... +Y : bottom ... top -Z ... +Z : farther ... closer

The axis data is not changed when the phone is rotated.

See also
  SDL_GetDisplayOrientation()

Definition at line 97 of file SDL_sensor.h.

## Typedef Documentation

## SDL_SensorID

typedef Sint32 SDL_SensorID

This is a unique ID for a sensor for the time it is connected to the system, and is never reused for the lifetime of the application.

The ID value starts at 0 and increments from there. The value -1 is an invalid ID.

Definition at line 60 of file SDL_sensor.h.

## Enumeration Type Documentation

## SDL_SensorType

enum SDL_SensorType

Enumerator
SDL_SENSOR_INVALID | Returned for an invalid sensor
SDL_SENSOR_UNKNOWN | Unknown sensor type
SDL_SENSOR_ACCEL | Accelerometer
SDL_SENSOR_GYRO | Gyroscope

Definition at line 69 of file SDL_sensor.h.

{
SDL_SENSOR_INVALID = -1, /**< Returned for an invalid sensor */
SDL_SENSOR_UNKNOWN, /**< Unknown sensor type */
SDL_SENSOR_ACCEL, /**< Accelerometer */
SDL_SENSOR_GYRO /**< Gyroscope */
} SDL_SensorType;

## Function Documentation

## SDL_NumSensors()

int SDL_NumSensors | ( | void |  | ) |

Count the number of sensors attached to the system right now.

Gyroscope sensor

The gyroscope returns the current rate of rotation in radians per second. The rotation is positive in the counter-clockwise direction. That is, an observer looking from a positive location on one of the axes would see positive rotation on that axis when it appeared to be rotating counter-clockwise.

values[0]: Angular speed around the x axis values[1]: Angular speed around the y axis values[2]: Angular speed around the z axis

For phones held in portrait mode, the axes are defined as follows: -X ... +X : left ... right -Y ... +Y : bottom ... top -Z ... +Z : farther ... closer

The axis data is not changed when the phone is rotated.

See also
  SDL_GetDisplayOrientation()

Definition at line 97 of file SDL_sensor.c.

{
int i, total_sensors = 0;
SDL_LockSensors();
for (i = 0; i < SDL_arraysize(SDL_sensor_drivers); ++i) {
total_sensors += SDL_sensor_drivers[i]->GetCount();
}
SDL_UnlockSensors();
return total_sensors;
}

References i, SDL_arraysize, SDL_LockSensors(), SDL_sensor_drivers, and SDL_UnlockSensors().

## SDL_SensorClose()

void SDL_SensorClose | ( | SDL_Sensor * | sensor | ) |

Close a sensor previously opened with SDL_SensorOpen()

Definition at line 390 of file SDL_sensor.c.

{
SDL_Sensor *sensorlist;
SDL_Sensor *sensorlistprev;
if (!SDL_PrivateSensorValid(sensor)) {
return;
}
SDL_LockSensors();
/* First decrement ref count */
if (--sensor->ref_count > 0) {
SDL_UnlockSensors();
return;
}
if (SDL_updating_sensor) {
SDL_UnlockSensors();
return;
}
sensor->driver->Close(sensor);
sensor->hwdata = NULL;
sensorlist = SDL_sensors;
sensorlistprev = NULL;
while (sensorlist) {
if (sensor == sensorlist) {
if (sensorlistprev) {
/* unlink this entry */
sensorlistprev->next = sensorlist->next;
} else {
SDL_sensors = sensor->next;
}
break;
}
sensorlistprev = sensorlist;
sensorlist = sensorlist->next;
}
SDL_free(sensor->name);
/* Free the data associated with this sensor */
SDL_free(sensor);
SDL_UnlockSensors();
}

References NULL, SDL_free, SDL_LockSensors(), SDL_PrivateSensorValid(), SDL_sensors, SDL_UnlockSensors(), and SDL_updating_sensor.

Referenced by SDL_SensorQuit(), and SDL_SensorUpdate().

## SDL_SensorFromInstanceID()

SDL_Sensor* SDL_SensorFromInstanceID | ( | SDL_SensorID | instance_id | ) |

Return the SDL_Sensor associated with an instance id.

Definition at line 287 of file SDL_sensor.c.

{
SDL_Sensor *sensor;
SDL_LockSensors();
for (sensor = SDL_sensors; sensor; sensor = sensor->next) {
if (sensor->instance_id == instance_id) {
break;
}
}
SDL_UnlockSensors();
return sensor;
}

References SDL_LockSensors(), SDL_sensors, and SDL_UnlockSensors().

## SDL_SensorGetData()

int SDL_SensorGetData | ( | SDL_Sensor * | sensor,
|  | float * | data,
|  | int | num_values
| ) |  |

Get the current state of an opened sensor.

The number of values and interpretation of the data is sensor dependent.

Parameters

  sensor | The sensor to query
  data | A pointer filled with the current sensor state
  num_values | The number of values to write to data

Returns
  0 or -1 if an error occurred.

Definition at line 375 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return -1;
}
num_values = SDL_min(num_values, SDL_arraysize(sensor->data));
SDL_memcpy(data, sensor->data, num_values*sizeof(*data));
return 0;
}

References SDL_arraysize, SDL_memcpy, SDL_min, and SDL_PrivateSensorValid().

## SDL_SensorGetDeviceInstanceID()

SDL_SensorID SDL_SensorGetDeviceInstanceID | ( | int | device_index | ) |

Get the instance ID of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor instance ID, or -1 if device_index is out of range.

Definition at line 193 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
SDL_SensorID instance_id = -1;
SDL_LockSensors();
if (SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
instance_id = driver->GetDeviceInstanceID(device_index);
}
SDL_UnlockSensors();
return instance_id;
}

References SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), and SDL_UnlockSensors().

## SDL_SensorGetDeviceName()

const char* SDL_SensorGetDeviceName | ( | int | device_index | ) |

Get the implementation dependent name of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor name, or NULL if device_index is out of range.

Definition at line 147 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
const char *name = NULL;
SDL_LockSensors();
if (SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
name = driver->GetDeviceName(device_index);
}
SDL_UnlockSensors();
/* FIXME: Really we should reference count this name so it doesn't go away after unlock */
return name;
}

References NULL, SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), and SDL_UnlockSensors().

## SDL_SensorGetDeviceNonPortableType()

int SDL_SensorGetDeviceNonPortableType | ( | int | device_index | ) |

Get the platform dependent type of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor platform dependent type, or -1 if device_index is out of range.

Definition at line 178 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
int type = -1;
SDL_LockSensors();
if (SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
type = driver->GetDeviceNonPortableType(device_index);
}
SDL_UnlockSensors();
return type;
}

References SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), and SDL_UnlockSensors().

## SDL_SensorGetDeviceType()

SDL_SensorType SDL_SensorGetDeviceType | ( | int | device_index | ) |

Get the type of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor type, or SDL_SENSOR_INVALID if device_index is out of range.

Definition at line 163 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
SDL_SensorType type = SDL_SENSOR_INVALID;
SDL_LockSensors();
if (SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
type = driver->GetDeviceType(device_index);
}
SDL_UnlockSensors();
return type;
}

References SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), SDL_SENSOR_INVALID, and SDL_UnlockSensors().

## SDL_SensorGetInstanceID()

SDL_SensorID SDL_SensorGetInstanceID | ( | SDL_Sensor * | sensor | ) |

Get the instance ID of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor instance ID, or -1 if the sensor is NULL.

Definition at line 362 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return -1;
}
return sensor->instance_id;
}

References SDL_PrivateSensorValid().

## SDL_SensorGetName()

const char* SDL_SensorGetName | ( | SDL_Sensor * | sensor | ) |

Get the implementation dependent name of a sensor.

Returns
  The sensor name, or NULL if the sensor is NULL.

Definition at line 323 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return NULL;
}
return sensor->name;
}

References NULL, and SDL_PrivateSensorValid().

## SDL_SensorGetNonPortableType()

int SDL_SensorGetNonPortableType | ( | SDL_Sensor * | sensor | ) |

Get the platform dependent type of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor platform dependent type, or -1 if the sensor is NULL.

Definition at line 349 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return -1;
}
return sensor->non_portable_type;
}

References SDL_PrivateSensorValid().

## SDL_SensorGetType()

SDL_SensorType SDL_SensorGetType | ( | SDL_Sensor * | sensor | ) |

Get the type of a sensor.

This can be called before any sensors are opened.

Returns
  The sensor type, or SDL_SENSOR_INVALID if the sensor is NULL.

Definition at line 336 of file SDL_sensor.c.

{
if (!SDL_PrivateSensorValid(sensor)) {
return SDL_SENSOR_INVALID;
}
return sensor->type;
}

References SDL_PrivateSensorValid(), and SDL_SENSOR_INVALID.

## SDL_SensorOpen()

SDL_Sensor* SDL_SensorOpen | ( | int | device_index | ) |

Open a sensor for use.

The index passed as an argument refers to the N'th sensor on the system.

Returns
  A sensor identifier, or NULL if an error occurred.

Definition at line 215 of file SDL_sensor.c.

{
SDL_SensorDriver *driver;
SDL_SensorID instance_id;
SDL_Sensor *sensor;
SDL_Sensor *sensorlist;
const char *sensorname = NULL;
SDL_LockSensors();
if (!SDL_GetDriverAndSensorIndex(device_index, &driver, &device_index)) {
SDL_UnlockSensors();
return NULL;
}
sensorlist = SDL_sensors;
/* If the sensor is already open, return it
* it is important that we have a single sensor * for each instance id
*/
instance_id = driver->GetDeviceInstanceID(device_index);
while (sensorlist) {
if (instance_id == sensorlist->instance_id) {
sensor = sensorlist;
++sensor->ref_count;
SDL_UnlockSensors();
return sensor;
}
sensorlist = sensorlist->next;
}
/* Create and initialize the sensor */
sensor = (SDL_Sensor *) SDL_calloc(sizeof(*sensor), 1);
if (sensor == NULL) {
SDL_OutOfMemory();
SDL_UnlockSensors();
return NULL;
}
sensor->driver = driver;
sensor->instance_id = instance_id;
sensor->type = driver->GetDeviceType(device_index);
sensor->non_portable_type = driver->GetDeviceNonPortableType(device_index);
if (driver->Open(sensor, device_index) < 0) {
SDL_free(sensor);
SDL_UnlockSensors();
return NULL;
}
sensorname = driver->GetDeviceName(device_index);
if (sensorname) {
sensor->name = SDL_strdup(sensorname);
} else {
sensor->name = NULL;
}
/* Add sensor to list */
++sensor->ref_count;
/* Link the sensor in the list */
sensor->next = SDL_sensors;
SDL_sensors = sensor;
SDL_UnlockSensors();
driver->Update(sensor);
return sensor;
}

References NULL, SDL_calloc, SDL_free, SDL_GetDriverAndSensorIndex(), SDL_LockSensors(), SDL_OutOfMemory, SDL_sensors, SDL_strdup, and SDL_UnlockSensors().

## SDL_SensorUpdate()

void SDL_SensorUpdate | ( | void |  | ) |

Update the current state of the open sensors.

This is called automatically by the event loop if sensor events are enabled.

This needs to be called from the thread that initialized the sensor subsystem.

Definition at line 738 of file SDL_dynapi_procs.h.

References i, SDL_arraysize, SDL_FALSE, SDL_INIT_SENSOR, SDL_LockSensors(), SDL_sensor_drivers, SDL_SensorClose(), SDL_sensors, SDL_TRUE, SDL_UnlockSensors(), SDL_updating_sensor, and SDL_WasInit.

SDL_updating_sensor
static SDL_bool SDL_updating_sensor
Definition: SDL_sensor.c:47
SDL_SENSOR_UNKNOWN
@ SDL_SENSOR_UNKNOWN
Definition: SDL_sensor.h:72
NULL
#define NULL
Definition: begin_code.h:167
SDL_LockSensors
static void SDL_LockSensors(void)
Definition: SDL_sensor.c:52
SDL_GetDriverAndSensorIndex
static SDL_bool SDL_GetDriverAndSensorIndex(int device_index, SDL_SensorDriver **driver, int *driver_index)
Definition: SDL_sensor.c:122
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974
SDL_SENSOR_GYRO
@ SDL_SENSOR_GYRO
Definition: SDL_sensor.h:74
SDL_SensorType
SDL_SensorType
Definition: SDL_sensor.h:69
SDL_memcpy
#define SDL_memcpy
Definition: SDL_dynapi_overrides.h:387
SDL_free
#define SDL_free
Definition: SDL_dynapi_overrides.h:377
name
GLuint const GLchar * name
Definition: SDL_opengl_glext.h:660
SDL_min
#define SDL_min(x, y)
Definition: SDL_stdinc.h:406
SDL_SENSOR_INVALID
@ SDL_SENSOR_INVALID
Definition: SDL_sensor.h:71
SDL_OutOfMemory
#define SDL_OutOfMemory()
Definition: SDL_error.h:52
SDL_sensor_drivers
static SDL_SensorDriver * SDL_sensor_drivers[]
Definition: SDL_sensor.c:35
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:115
SDL_calloc
#define SDL_calloc
Definition: SDL_dynapi_overrides.h:375
SDL_sensors
static SDL_Sensor * SDL_sensors
Definition: SDL_sensor.c:46
SDL_PrivateSensorValid
static int SDL_PrivateSensorValid(SDL_Sensor *sensor)
Definition: SDL_sensor.c:305
SDL_strdup
#define SDL_strdup
Definition: SDL_dynapi_overrides.h:397
SDL_SENSOR_ACCEL
@ SDL_SENSOR_ACCEL
Definition: SDL_sensor.h:73
type
GLuint GLuint GLsizei GLenum type
Definition: SDL_opengl.h:1571
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_UnlockSensors
static void SDL_UnlockSensors(void)
Definition: SDL_sensor.c:60
SDL_SensorID
Sint32 SDL_SensorID
Definition: SDL_sensor.h:60